{
  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";
    flake-utils.url = "github:numtide/flake-utils";
    fenix.url = "github:nix-community/fenix";
  };

  outputs =
    {
      nixpkgs,
      fenix,
      flake-utils,
      ...
    }:
    flake-utils.lib.eachDefaultSystem (
      system:
      let
        pkgs = import nixpkgs { inherit system; };
        fx = fenix.packages.${system};
        rust = fx.combine [
          (fx.fromToolchainFile {
            file = ./rust-toolchain.toml;
            sha256 = "sha256-KUm16pHj+cRedf8vxs/Hd2YWxpOrWZ7UOrwhILdSJBU=";
          })
        ];
        buildInputs = [
          rust
          pkgs.cargo-deny
        ];
      in
      {
        devShells.default = pkgs.mkShell {
          buildInputs = buildInputs;
        };
      }
    );
}
